// Code generated by github.com/varlink/go/cmd/varlink-go-interface-generator, DO NOT EDIT.

// Interface to test varlink implementations against.
// First you write a varlink client calling:
// Start, Test01, Test02, …, Test09, End
// The return value of the previous call should be the argument of the next call.
// Then you test this client against well known servers like python or rust from
// https://github.com/varlink/
// # Next you write a varlink server providing the same service as the well known ones.
// Now run your client against it and run well known clients like python or rust
// from https://github.com/varlink/ against your server. If all works out, then
// your new language bindings should be varlink certified.
package orgvarlinkcertification

import (
	"context"
	"encoding/json"
	"fmt"
	"github.com/varlink/go/varlink"
)

// Generated type declarations

type Interface struct {
	Foo  *[]*map[string]string `json:"foo,omitempty"`
	Anon struct {
		Foo bool `json:"foo"`
		Bar bool `json:"bar"`
	} `json:"anon"`
}

type MyType struct {
	Object json.RawMessage `json:"object"`
	Enum   string          `json:"enum"`
	Struct struct {
		First  int64  `json:"first"`
		Second string `json:"second"`
	} `json:"struct"`
	Array                 []string            `json:"array"`
	Dictionary            map[string]string   `json:"dictionary"`
	Stringset             map[string]struct{} `json:"stringset"`
	Nullable              *string             `json:"nullable,omitempty"`
	Nullable_array_struct *[]struct {
		First  int64  `json:"first"`
		Second string `json:"second"`
	} `json:"nullable_array_struct,omitempty"`
	Interface Interface `json:"interface"`
}

type ClientIdError struct{}

func (e ClientIdError) Error() string {
	s := "org.varlink.certification.ClientIdError"
	return s
}

type CertificationError struct {
	Wants json.RawMessage `json:"wants"`
	Got   json.RawMessage `json:"got"`
}

func (e CertificationError) Error() string {
	s := "org.varlink.certification.CertificationError"
	s += fmt.Sprintf("(Wants: %v, Got: %v)", e.Wants, e.Got)
	return s
}

func Dispatch_Error(err error) error {
	if e, ok := err.(*varlink.Error); ok {
		switch e.Name {
		case "org.varlink.certification.ClientIdError":
			errorRawParameters := e.Parameters.(*json.RawMessage)
			if errorRawParameters == nil {
				return e
			}
			var param ClientIdError
			err := json.Unmarshal(*errorRawParameters, &param)
			if err != nil {
				return e
			}
			return &param
		case "org.varlink.certification.CertificationError":
			errorRawParameters := e.Parameters.(*json.RawMessage)
			if errorRawParameters == nil {
				return e
			}
			var param CertificationError
			err := json.Unmarshal(*errorRawParameters, &param)
			if err != nil {
				return e
			}
			return &param
		}
	}
	return err
}

// Generated client method calls

type Start_methods struct{}

func Start() Start_methods { return Start_methods{} }

func (m Start_methods) Call(ctx context.Context, c *varlink.Connection) (client_id_out_ string, err_ error) {
	receive, err_ := m.Send(ctx, c, 0)
	if err_ != nil {
		return
	}
	client_id_out_, _, err_ = receive(ctx)
	return
}

func (m Start_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64) (func(ctx context.Context) (string, uint64, error), error) {
	receive, err := c.Send(ctx, "org.varlink.certification.Start", nil, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (client_id_out_ string, flags uint64, err error) {
		var out struct {
			Client_id string `json:"client_id"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		client_id_out_ = out.Client_id
		return
	}, nil
}

func (m Start_methods) Upgrade(ctx context.Context, c *varlink.Connection) (func(ctx context.Context) (client_id_out_ string, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Start", nil)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (client_id_out_ string, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Client_id string `json:"client_id"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		client_id_out_ = out.Client_id
		return
	}, nil
}

type Test01_methods struct{}

func Test01() Test01_methods { return Test01_methods{} }

func (m Test01_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string) (bool_out_ bool, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_)
	if err_ != nil {
		return
	}
	bool_out_, _, err_ = receive(ctx)
	return
}

func (m Test01_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string) (func(ctx context.Context) (bool, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
	}
	in.Client_id = client_id_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test01", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (bool_out_ bool, flags uint64, err error) {
		var out struct {
			Bool bool `json:"bool"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		bool_out_ = out.Bool
		return
	}, nil
}

func (m Test01_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string) (func(ctx context.Context) (bool_out_ bool, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
	}
	in.Client_id = client_id_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test01", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (bool_out_ bool, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Bool bool `json:"bool"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		bool_out_ = out.Bool
		return
	}, nil
}

type Test02_methods struct{}

func Test02() Test02_methods { return Test02_methods{} }

func (m Test02_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, bool_in_ bool) (int_out_ int64, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, bool_in_)
	if err_ != nil {
		return
	}
	int_out_, _, err_ = receive(ctx)
	return
}

func (m Test02_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, bool_in_ bool) (func(ctx context.Context) (int64, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Bool      bool   `json:"bool"`
	}
	in.Client_id = client_id_in_
	in.Bool = bool_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test02", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (int_out_ int64, flags uint64, err error) {
		var out struct {
			Int int64 `json:"int"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		int_out_ = out.Int
		return
	}, nil
}

func (m Test02_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, bool_in_ bool) (func(ctx context.Context) (int_out_ int64, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Bool      bool   `json:"bool"`
	}
	in.Client_id = client_id_in_
	in.Bool = bool_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test02", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (int_out_ int64, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Int int64 `json:"int"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		int_out_ = out.Int
		return
	}, nil
}

type Test03_methods struct{}

func Test03() Test03_methods { return Test03_methods{} }

func (m Test03_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, int_in_ int64) (float_out_ float64, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, int_in_)
	if err_ != nil {
		return
	}
	float_out_, _, err_ = receive(ctx)
	return
}

func (m Test03_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, int_in_ int64) (func(ctx context.Context) (float64, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Int       int64  `json:"int"`
	}
	in.Client_id = client_id_in_
	in.Int = int_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test03", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (float_out_ float64, flags uint64, err error) {
		var out struct {
			Float float64 `json:"float"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		float_out_ = out.Float
		return
	}, nil
}

func (m Test03_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, int_in_ int64) (func(ctx context.Context) (float_out_ float64, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Int       int64  `json:"int"`
	}
	in.Client_id = client_id_in_
	in.Int = int_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test03", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (float_out_ float64, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Float float64 `json:"float"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		float_out_ = out.Float
		return
	}, nil
}

type Test04_methods struct{}

func Test04() Test04_methods { return Test04_methods{} }

func (m Test04_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, float_in_ float64) (string_out_ string, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, float_in_)
	if err_ != nil {
		return
	}
	string_out_, _, err_ = receive(ctx)
	return
}

func (m Test04_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, float_in_ float64) (func(ctx context.Context) (string, uint64, error), error) {
	var in struct {
		Client_id string  `json:"client_id"`
		Float     float64 `json:"float"`
	}
	in.Client_id = client_id_in_
	in.Float = float_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test04", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (string_out_ string, flags uint64, err error) {
		var out struct {
			String string `json:"string"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		string_out_ = out.String
		return
	}, nil
}

func (m Test04_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, float_in_ float64) (func(ctx context.Context) (string_out_ string, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string  `json:"client_id"`
		Float     float64 `json:"float"`
	}
	in.Client_id = client_id_in_
	in.Float = float_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test04", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (string_out_ string, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			String string `json:"string"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		string_out_ = out.String
		return
	}, nil
}

type Test05_methods struct{}

func Test05() Test05_methods { return Test05_methods{} }

func (m Test05_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, string_in_ string) (bool_out_ bool, int_out_ int64, float_out_ float64, string_out_ string, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, string_in_)
	if err_ != nil {
		return
	}
	bool_out_, int_out_, float_out_, string_out_, _, err_ = receive(ctx)
	return
}

func (m Test05_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, string_in_ string) (func(ctx context.Context) (bool, int64, float64, string, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		String    string `json:"string"`
	}
	in.Client_id = client_id_in_
	in.String = string_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test05", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (bool_out_ bool, int_out_ int64, float_out_ float64, string_out_ string, flags uint64, err error) {
		var out struct {
			Bool   bool    `json:"bool"`
			Int    int64   `json:"int"`
			Float  float64 `json:"float"`
			String string  `json:"string"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		bool_out_ = out.Bool
		int_out_ = out.Int
		float_out_ = out.Float
		string_out_ = out.String
		return
	}, nil
}

func (m Test05_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, string_in_ string) (func(ctx context.Context) (bool_out_ bool, int_out_ int64, float_out_ float64, string_out_ string, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		String    string `json:"string"`
	}
	in.Client_id = client_id_in_
	in.String = string_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test05", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (bool_out_ bool, int_out_ int64, float_out_ float64, string_out_ string, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Bool   bool    `json:"bool"`
			Int    int64   `json:"int"`
			Float  float64 `json:"float"`
			String string  `json:"string"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		bool_out_ = out.Bool
		int_out_ = out.Int
		float_out_ = out.Float
		string_out_ = out.String
		return
	}, nil
}

type Test06_methods struct{}

func Test06() Test06_methods { return Test06_methods{} }

func (m Test06_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, bool_in_ bool, int_in_ int64, float_in_ float64, string_in_ string) (struct_out_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, bool_in_, int_in_, float_in_, string_in_)
	if err_ != nil {
		return
	}
	struct_out_, _, err_ = receive(ctx)
	return
}

func (m Test06_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, bool_in_ bool, int_in_ int64, float_in_ float64, string_in_ string) (func(ctx context.Context) (struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}, uint64, error), error) {
	var in struct {
		Client_id string  `json:"client_id"`
		Bool      bool    `json:"bool"`
		Int       int64   `json:"int"`
		Float     float64 `json:"float"`
		String    string  `json:"string"`
	}
	in.Client_id = client_id_in_
	in.Bool = bool_in_
	in.Int = int_in_
	in.Float = float_in_
	in.String = string_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test06", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (struct_out_ struct {
		Bool   bool
		Int    int64
		Float  float64
		String string
	}, flags uint64, err error) {
		var out struct {
			Struct struct {
				Bool   bool    `json:"bool"`
				Int    int64   `json:"int"`
				Float  float64 `json:"float"`
				String string  `json:"string"`
			} `json:"struct"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		struct_out_ = struct {
			Bool   bool
			Int    int64
			Float  float64
			String string
		}(out.Struct)
		return
	}, nil
}

func (m Test06_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, bool_in_ bool, int_in_ int64, float_in_ float64, string_in_ string) (func(ctx context.Context) (struct_out_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string  `json:"client_id"`
		Bool      bool    `json:"bool"`
		Int       int64   `json:"int"`
		Float     float64 `json:"float"`
		String    string  `json:"string"`
	}
	in.Client_id = client_id_in_
	in.Bool = bool_in_
	in.Int = int_in_
	in.Float = float_in_
	in.String = string_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test06", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (struct_out_ struct {
		Bool   bool
		Int    int64
		Float  float64
		String string
	}, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Struct struct {
				Bool   bool    `json:"bool"`
				Int    int64   `json:"int"`
				Float  float64 `json:"float"`
				String string  `json:"string"`
			} `json:"struct"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		struct_out_ = struct {
			Bool   bool
			Int    int64
			Float  float64
			String string
		}(out.Struct)
		return
	}, nil
}

type Test07_methods struct{}

func Test07() Test07_methods { return Test07_methods{} }

func (m Test07_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, struct_in_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}) (map_out_ map[string]string, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, struct_in_)
	if err_ != nil {
		return
	}
	map_out_, _, err_ = receive(ctx)
	return
}

func (m Test07_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, struct_in_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}) (func(ctx context.Context) (map[string]string, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Struct    struct {
			Bool   bool    `json:"bool"`
			Int    int64   `json:"int"`
			Float  float64 `json:"float"`
			String string  `json:"string"`
		} `json:"struct"`
	}
	in.Client_id = client_id_in_
	in.Struct = struct {
		Bool   bool    `json:"bool"`
		Int    int64   `json:"int"`
		Float  float64 `json:"float"`
		String string  `json:"string"`
	}(struct_in_)
	receive, err := c.Send(ctx, "org.varlink.certification.Test07", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (map_out_ map[string]string, flags uint64, err error) {
		var out struct {
			Map map[string]string `json:"map"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		map_out_ = map[string]string(out.Map)
		return
	}, nil
}

func (m Test07_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, struct_in_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}) (func(ctx context.Context) (map_out_ map[string]string, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Struct    struct {
			Bool   bool    `json:"bool"`
			Int    int64   `json:"int"`
			Float  float64 `json:"float"`
			String string  `json:"string"`
		} `json:"struct"`
	}
	in.Client_id = client_id_in_
	in.Struct = struct {
		Bool   bool    `json:"bool"`
		Int    int64   `json:"int"`
		Float  float64 `json:"float"`
		String string  `json:"string"`
	}(struct_in_)
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test07", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (map_out_ map[string]string, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Map map[string]string `json:"map"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		map_out_ = map[string]string(out.Map)
		return
	}, nil
}

type Test08_methods struct{}

func Test08() Test08_methods { return Test08_methods{} }

func (m Test08_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, map_in_ map[string]string) (set_out_ map[string]struct{}, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, map_in_)
	if err_ != nil {
		return
	}
	set_out_, _, err_ = receive(ctx)
	return
}

func (m Test08_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, map_in_ map[string]string) (func(ctx context.Context) (map[string]struct{}, uint64, error), error) {
	var in struct {
		Client_id string            `json:"client_id"`
		Map       map[string]string `json:"map"`
	}
	in.Client_id = client_id_in_
	in.Map = map[string]string(map_in_)
	receive, err := c.Send(ctx, "org.varlink.certification.Test08", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (set_out_ map[string]struct{}, flags uint64, err error) {
		var out struct {
			Set map[string]struct{} `json:"set"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		set_out_ = map[string]struct{}(out.Set)
		return
	}, nil
}

func (m Test08_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, map_in_ map[string]string) (func(ctx context.Context) (set_out_ map[string]struct{}, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string            `json:"client_id"`
		Map       map[string]string `json:"map"`
	}
	in.Client_id = client_id_in_
	in.Map = map[string]string(map_in_)
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test08", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (set_out_ map[string]struct{}, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Set map[string]struct{} `json:"set"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		set_out_ = map[string]struct{}(out.Set)
		return
	}, nil
}

type Test09_methods struct{}

func Test09() Test09_methods { return Test09_methods{} }

func (m Test09_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, set_in_ map[string]struct{}) (mytype_out_ MyType, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, set_in_)
	if err_ != nil {
		return
	}
	mytype_out_, _, err_ = receive(ctx)
	return
}

func (m Test09_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, set_in_ map[string]struct{}) (func(ctx context.Context) (MyType, uint64, error), error) {
	var in struct {
		Client_id string              `json:"client_id"`
		Set       map[string]struct{} `json:"set"`
	}
	in.Client_id = client_id_in_
	in.Set = map[string]struct{}(set_in_)
	receive, err := c.Send(ctx, "org.varlink.certification.Test09", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (mytype_out_ MyType, flags uint64, err error) {
		var out struct {
			Mytype MyType `json:"mytype"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		mytype_out_ = out.Mytype
		return
	}, nil
}

func (m Test09_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, set_in_ map[string]struct{}) (func(ctx context.Context) (mytype_out_ MyType, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string              `json:"client_id"`
		Set       map[string]struct{} `json:"set"`
	}
	in.Client_id = client_id_in_
	in.Set = map[string]struct{}(set_in_)
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test09", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (mytype_out_ MyType, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			Mytype MyType `json:"mytype"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		mytype_out_ = out.Mytype
		return
	}, nil
}

// returns more than one reply with "continues"
type Test10_methods struct{}

func Test10() Test10_methods { return Test10_methods{} }

func (m Test10_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, mytype_in_ MyType) (string_out_ string, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, mytype_in_)
	if err_ != nil {
		return
	}
	string_out_, _, err_ = receive(ctx)
	return
}

func (m Test10_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, mytype_in_ MyType) (func(ctx context.Context) (string, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Mytype    MyType `json:"mytype"`
	}
	in.Client_id = client_id_in_
	in.Mytype = mytype_in_
	receive, err := c.Send(ctx, "org.varlink.certification.Test10", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (string_out_ string, flags uint64, err error) {
		var out struct {
			String string `json:"string"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		string_out_ = out.String
		return
	}, nil
}

func (m Test10_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, mytype_in_ MyType) (func(ctx context.Context) (string_out_ string, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
		Mytype    MyType `json:"mytype"`
	}
	in.Client_id = client_id_in_
	in.Mytype = mytype_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test10", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (string_out_ string, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			String string `json:"string"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		string_out_ = out.String
		return
	}, nil
}

type Test11_methods struct{}

func Test11() Test11_methods { return Test11_methods{} }

func (m Test11_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string, last_more_replies_in_ []string) (err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_, last_more_replies_in_)
	if err_ != nil {
		return
	}
	_, err_ = receive(ctx)
	return
}

func (m Test11_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string, last_more_replies_in_ []string) (func(ctx context.Context) (uint64, error), error) {
	var in struct {
		Client_id         string   `json:"client_id"`
		Last_more_replies []string `json:"last_more_replies"`
	}
	in.Client_id = client_id_in_
	in.Last_more_replies = []string(last_more_replies_in_)
	receive, err := c.Send(ctx, "org.varlink.certification.Test11", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (flags uint64, err error) {
		flags, err = receive(ctx, nil)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		return
	}, nil
}

func (m Test11_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string, last_more_replies_in_ []string) (func(ctx context.Context) (flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id         string   `json:"client_id"`
		Last_more_replies []string `json:"last_more_replies"`
	}
	in.Client_id = client_id_in_
	in.Last_more_replies = []string(last_more_replies_in_)
	receive, err := c.Upgrade(ctx, "org.varlink.certification.Test11", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (flags uint64, conn varlink.ReadWriterContext, err error) {
		flags, conn, err = receive(ctx, nil)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		return
	}, nil
}

type End_methods struct{}

func End() End_methods { return End_methods{} }

func (m End_methods) Call(ctx context.Context, c *varlink.Connection, client_id_in_ string) (all_ok_out_ bool, err_ error) {
	receive, err_ := m.Send(ctx, c, 0, client_id_in_)
	if err_ != nil {
		return
	}
	all_ok_out_, _, err_ = receive(ctx)
	return
}

func (m End_methods) Send(ctx context.Context, c *varlink.Connection, flags uint64, client_id_in_ string) (func(ctx context.Context) (bool, uint64, error), error) {
	var in struct {
		Client_id string `json:"client_id"`
	}
	in.Client_id = client_id_in_
	receive, err := c.Send(ctx, "org.varlink.certification.End", in, flags)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (all_ok_out_ bool, flags uint64, err error) {
		var out struct {
			All_ok bool `json:"all_ok"`
		}
		flags, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		all_ok_out_ = out.All_ok
		return
	}, nil
}

func (m End_methods) Upgrade(ctx context.Context, c *varlink.Connection, client_id_in_ string) (func(ctx context.Context) (all_ok_out_ bool, flags uint64, conn varlink.ReadWriterContext, err_ error), error) {
	var in struct {
		Client_id string `json:"client_id"`
	}
	in.Client_id = client_id_in_
	receive, err := c.Upgrade(ctx, "org.varlink.certification.End", in)
	if err != nil {
		return nil, err
	}
	return func(context.Context) (all_ok_out_ bool, flags uint64, conn varlink.ReadWriterContext, err error) {
		var out struct {
			All_ok bool `json:"all_ok"`
		}
		flags, conn, err = receive(ctx, &out)
		if err != nil {
			err = Dispatch_Error(err)
			return
		}
		all_ok_out_ = out.All_ok
		return
	}, nil
}

// Generated service interface with all methods

type orgvarlinkcertificationInterface interface {
	Start(ctx context.Context, c VarlinkCall) error
	Test01(ctx context.Context, c VarlinkCall, client_id_ string) error
	Test02(ctx context.Context, c VarlinkCall, client_id_ string, bool_ bool) error
	Test03(ctx context.Context, c VarlinkCall, client_id_ string, int_ int64) error
	Test04(ctx context.Context, c VarlinkCall, client_id_ string, float_ float64) error
	Test05(ctx context.Context, c VarlinkCall, client_id_ string, string_ string) error
	Test06(ctx context.Context, c VarlinkCall, client_id_ string, bool_ bool, int_ int64, float_ float64, string_ string) error
	Test07(ctx context.Context, c VarlinkCall, client_id_ string, struct_ struct {
		Bool   bool
		Int    int64
		Float  float64
		String string
	}) error
	Test08(ctx context.Context, c VarlinkCall, client_id_ string, map_ map[string]string) error
	Test09(ctx context.Context, c VarlinkCall, client_id_ string, set_ map[string]struct{}) error
	Test10(ctx context.Context, c VarlinkCall, client_id_ string, mytype_ MyType) error
	Test11(ctx context.Context, c VarlinkCall, client_id_ string, last_more_replies_ []string) error
	End(ctx context.Context, c VarlinkCall, client_id_ string) error
}

// Generated service object with all methods

type VarlinkCall struct{ varlink.Call }

// Generated reply methods for all varlink errors

func (c *VarlinkCall) ReplyClientIdError(ctx context.Context) error {
	var out ClientIdError
	return c.ReplyError(ctx, "org.varlink.certification.ClientIdError", &out)
}

func (c *VarlinkCall) ReplyCertificationError(ctx context.Context, wants_ json.RawMessage, got_ json.RawMessage) error {
	var out CertificationError
	out.Wants = wants_
	out.Got = got_
	return c.ReplyError(ctx, "org.varlink.certification.CertificationError", &out)
}

// Generated reply methods for all varlink methods

func (c *VarlinkCall) ReplyStart(ctx context.Context, client_id_ string) error {
	var out struct {
		Client_id string `json:"client_id"`
	}
	out.Client_id = client_id_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest01(ctx context.Context, bool_ bool) error {
	var out struct {
		Bool bool `json:"bool"`
	}
	out.Bool = bool_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest02(ctx context.Context, int_ int64) error {
	var out struct {
		Int int64 `json:"int"`
	}
	out.Int = int_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest03(ctx context.Context, float_ float64) error {
	var out struct {
		Float float64 `json:"float"`
	}
	out.Float = float_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest04(ctx context.Context, string_ string) error {
	var out struct {
		String string `json:"string"`
	}
	out.String = string_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest05(ctx context.Context, bool_ bool, int_ int64, float_ float64, string_ string) error {
	var out struct {
		Bool   bool    `json:"bool"`
		Int    int64   `json:"int"`
		Float  float64 `json:"float"`
		String string  `json:"string"`
	}
	out.Bool = bool_
	out.Int = int_
	out.Float = float_
	out.String = string_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest06(ctx context.Context, struct_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}) error {
	var out struct {
		Struct struct {
			Bool   bool    `json:"bool"`
			Int    int64   `json:"int"`
			Float  float64 `json:"float"`
			String string  `json:"string"`
		} `json:"struct"`
	}
	out.Struct = struct {
		Bool   bool    `json:"bool"`
		Int    int64   `json:"int"`
		Float  float64 `json:"float"`
		String string  `json:"string"`
	}(struct_)
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest07(ctx context.Context, map_ map[string]string) error {
	var out struct {
		Map map[string]string `json:"map"`
	}
	out.Map = map[string]string(map_)
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest08(ctx context.Context, set_ map[string]struct{}) error {
	var out struct {
		Set map[string]struct{} `json:"set"`
	}
	out.Set = map[string]struct{}(set_)
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest09(ctx context.Context, mytype_ MyType) error {
	var out struct {
		Mytype MyType `json:"mytype"`
	}
	out.Mytype = mytype_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest10(ctx context.Context, string_ string) error {
	var out struct {
		String string `json:"string"`
	}
	out.String = string_
	return c.Reply(ctx, &out)
}

func (c *VarlinkCall) ReplyTest11(ctx context.Context) error {
	return c.Reply(ctx, nil)
}

func (c *VarlinkCall) ReplyEnd(ctx context.Context, all_ok_ bool) error {
	var out struct {
		All_ok bool `json:"all_ok"`
	}
	out.All_ok = all_ok_
	return c.Reply(ctx, &out)
}

// Generated dummy implementations for all varlink methods

func (s *VarlinkInterface) Start(ctx context.Context, c VarlinkCall) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Start")
}

func (s *VarlinkInterface) Test01(ctx context.Context, c VarlinkCall, client_id_ string) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test01")
}

func (s *VarlinkInterface) Test02(ctx context.Context, c VarlinkCall, client_id_ string, bool_ bool) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test02")
}

func (s *VarlinkInterface) Test03(ctx context.Context, c VarlinkCall, client_id_ string, int_ int64) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test03")
}

func (s *VarlinkInterface) Test04(ctx context.Context, c VarlinkCall, client_id_ string, float_ float64) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test04")
}

func (s *VarlinkInterface) Test05(ctx context.Context, c VarlinkCall, client_id_ string, string_ string) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test05")
}

func (s *VarlinkInterface) Test06(ctx context.Context, c VarlinkCall, client_id_ string, bool_ bool, int_ int64, float_ float64, string_ string) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test06")
}

func (s *VarlinkInterface) Test07(ctx context.Context, c VarlinkCall, client_id_ string, struct_ struct {
	Bool   bool
	Int    int64
	Float  float64
	String string
}) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test07")
}

func (s *VarlinkInterface) Test08(ctx context.Context, c VarlinkCall, client_id_ string, map_ map[string]string) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test08")
}

func (s *VarlinkInterface) Test09(ctx context.Context, c VarlinkCall, client_id_ string, set_ map[string]struct{}) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test09")
}

// returns more than one reply with "continues"
func (s *VarlinkInterface) Test10(ctx context.Context, c VarlinkCall, client_id_ string, mytype_ MyType) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test10")
}

func (s *VarlinkInterface) Test11(ctx context.Context, c VarlinkCall, client_id_ string, last_more_replies_ []string) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.Test11")
}

func (s *VarlinkInterface) End(ctx context.Context, c VarlinkCall, client_id_ string) error {
	return c.ReplyMethodNotImplemented(ctx, "org.varlink.certification.End")
}

// Generated method call dispatcher

func (s *VarlinkInterface) VarlinkDispatch(ctx context.Context, call varlink.Call, methodname string) error {
	switch methodname {
	case "Start":
		return s.orgvarlinkcertificationInterface.Start(ctx, VarlinkCall{call})

	case "Test01":
		var in struct {
			Client_id string `json:"client_id"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test01(ctx, VarlinkCall{call}, in.Client_id)

	case "Test02":
		var in struct {
			Client_id string `json:"client_id"`
			Bool      bool   `json:"bool"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test02(ctx, VarlinkCall{call}, in.Client_id, in.Bool)

	case "Test03":
		var in struct {
			Client_id string `json:"client_id"`
			Int       int64  `json:"int"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test03(ctx, VarlinkCall{call}, in.Client_id, in.Int)

	case "Test04":
		var in struct {
			Client_id string  `json:"client_id"`
			Float     float64 `json:"float"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test04(ctx, VarlinkCall{call}, in.Client_id, in.Float)

	case "Test05":
		var in struct {
			Client_id string `json:"client_id"`
			String    string `json:"string"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test05(ctx, VarlinkCall{call}, in.Client_id, in.String)

	case "Test06":
		var in struct {
			Client_id string  `json:"client_id"`
			Bool      bool    `json:"bool"`
			Int       int64   `json:"int"`
			Float     float64 `json:"float"`
			String    string  `json:"string"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test06(ctx, VarlinkCall{call}, in.Client_id, in.Bool, in.Int, in.Float, in.String)

	case "Test07":
		var in struct {
			Client_id string `json:"client_id"`
			Struct    struct {
				Bool   bool    `json:"bool"`
				Int    int64   `json:"int"`
				Float  float64 `json:"float"`
				String string  `json:"string"`
			} `json:"struct"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test07(ctx, VarlinkCall{call}, in.Client_id, struct {
			Bool   bool
			Int    int64
			Float  float64
			String string
		}(in.Struct))

	case "Test08":
		var in struct {
			Client_id string            `json:"client_id"`
			Map       map[string]string `json:"map"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test08(ctx, VarlinkCall{call}, in.Client_id, map[string]string(in.Map))

	case "Test09":
		var in struct {
			Client_id string              `json:"client_id"`
			Set       map[string]struct{} `json:"set"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test09(ctx, VarlinkCall{call}, in.Client_id, map[string]struct{}(in.Set))

	case "Test10":
		var in struct {
			Client_id string `json:"client_id"`
			Mytype    MyType `json:"mytype"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test10(ctx, VarlinkCall{call}, in.Client_id, in.Mytype)

	case "Test11":
		var in struct {
			Client_id         string   `json:"client_id"`
			Last_more_replies []string `json:"last_more_replies"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.Test11(ctx, VarlinkCall{call}, in.Client_id, []string(in.Last_more_replies))

	case "End":
		var in struct {
			Client_id string `json:"client_id"`
		}
		err := call.GetParameters(&in)
		if err != nil {
			return call.ReplyInvalidParameter(ctx, "parameters")
		}
		return s.orgvarlinkcertificationInterface.End(ctx, VarlinkCall{call}, in.Client_id)

	default:
		return call.ReplyMethodNotFound(ctx, methodname)
	}
}

// Generated varlink interface name

func (s *VarlinkInterface) VarlinkGetName() string {
	return `org.varlink.certification`
}

// Generated varlink interface description

func (s *VarlinkInterface) VarlinkGetDescription() string {
	return `# Interface to test varlink implementations against.
# First you write a varlink client calling:
# Start, Test01, Test02, …, Test09, End
# The return value of the previous call should be the argument of the next call.
# Then you test this client against well known servers like python or rust from
# https://github.com/varlink/
#
# Next you write a varlink server providing the same service as the well known ones.
# Now run your client against it and run well known clients like python or rust
# from https://github.com/varlink/ against your server. If all works out, then
# your new language bindings should be varlink certified.
interface org.varlink.certification

type Interface (
  foo: ?[]?[string](foo, bar, baz),
  anon: (foo: bool, bar: bool)
)

type MyType (
  object: object,
  enum: (one, two, three),
  struct: (first: int, second: string),
  array: []string,
  dictionary: [string]string,
  stringset: [string](),
  nullable: ?string,
  nullable_array_struct: ?[](first: int, second: string),
  interface: Interface
)

method Start() -> (client_id: string)

method Test01(client_id: string) -> (bool: bool)

method Test02(client_id: string, bool: bool) -> (int: int)

method Test03(client_id: string, int: int) -> (float: float)

method Test04(client_id: string, float: float) -> (string: string)

method Test05(client_id: string, string: string) -> (
  bool: bool,
  int: int,
  float: float,
  string: string
)

method Test06(
  client_id: string,
  bool: bool,
  int: int,
  float: float,
  string: string
) -> (
  struct: (
    bool: bool,
    int: int,
    float: float,
    string: string
  )
)

method Test07(
  client_id: string,
  struct: (
    bool: bool,
    int: int,
    float: float,
    string: string
  )
) -> (map: [string]string)

method Test08(client_id: string, map: [string]string) -> (set: [string]())

method Test09(client_id: string, set: [string]()) -> (mytype: MyType)

# returns more than one reply with "continues"
method Test10(client_id: string, mytype: MyType) -> (string: string)

method Test11(
  client_id: string,
  last_more_replies: []string
) -> ()

method End(client_id: string) -> (all_ok: bool)

error ClientIdError ()

error CertificationError (wants: object, got: object)
`
}

// Generated service interface

type VarlinkInterface struct {
	orgvarlinkcertificationInterface
}

func VarlinkNew(m orgvarlinkcertificationInterface) *VarlinkInterface {
	return &VarlinkInterface{m}
}
